(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'react', 'styled-components', 'react-dom', 'prop-types', '../theme/defaultTheme', '../styled/ScrollableWrap'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('react'), require('styled-components'), require('react-dom'), require('prop-types'), require('../theme/defaultTheme'), require('../styled/ScrollableWrap'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.react, global.styledComponents, global.reactDom, global.propTypes, global.defaultTheme, global.ScrollableWrap);
    global.Scrollable = mod.exports;
  }
})(this, function (exports, _react, _styledComponents, _reactDom, _propTypes, _defaultTheme, _ScrollableWrap) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _react2 = _interopRequireDefault(_react);

  var _styledComponents2 = _interopRequireDefault(_styledComponents);

  var _propTypes2 = _interopRequireDefault(_propTypes);

  var _defaultTheme2 = _interopRequireDefault(_defaultTheme);

  var _ScrollableWrap2 = _interopRequireDefault(_ScrollableWrap);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  var _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  function _objectWithoutProperties(obj, keys) {
    var target = {};

    for (var i in obj) {
      if (keys.indexOf(i) >= 0) continue;
      if (!Object.prototype.hasOwnProperty.call(obj, i)) continue;
      target[i] = obj[i];
    }

    return target;
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  var _createClass = function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  }();

  function _possibleConstructorReturn(self, call) {
    if (!self) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return call && (typeof call === "object" || typeof call === "function") ? call : self;
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
  }

  var _templateObject = _taggedTemplateLiteral(['\n  width: 100%;\n  height: 100%;\n  display: block;\n  overflow: hidden;\n  padding-right: 23px;\n'], ['\n  width: 100%;\n  height: 100%;\n  display: block;\n  overflow: hidden;\n  padding-right: 23px;\n']),
      _templateObject2 = _taggedTemplateLiteral(['\n  position: absolute;\n  right: 11px;\n  top: 15%;\n  bottom: 15%;\n  width: 1px;\n  background-color: #E6E6E6;\n  overflow: visible;\n'], ['\n  position: absolute;\n  right: 11px;\n  top: 15%;\n  bottom: 15%;\n  width: 1px;\n  background-color: #E6E6E6;\n  overflow: visible;\n']),
      _templateObject3 = _taggedTemplateLiteral(['\n  background-color: #0884FF;\n  width: 3px;\n  height: 92px;\n  display: inline-block;\n  position: relative;\n  right: 1px;\n  z-index: 2;\n  top: ', ';\n'], ['\n  background-color: #0884FF;\n  width: 3px;\n  height: 92px;\n  display: inline-block;\n  position: relative;\n  right: 1px;\n  z-index: 2;\n  top: ', ';\n']);

  function _taggedTemplateLiteral(strings, raw) {
    return Object.freeze(Object.defineProperties(strings, {
      raw: {
        value: Object.freeze(raw)
      }
    }));
  }

  var ComponentName = 'Scrollable';

  var InnerWrap = _styledComponents2.default.div.withConfig({
    displayName: 'Scrollable__InnerWrap'
  })(_templateObject);

  var Track = _styledComponents2.default.div.withConfig({
    displayName: 'Scrollable__Track'
  })(_templateObject2);

  var Thumb = _styledComponents2.default.div.withConfig({
    displayName: 'Scrollable__Thumb'
  })(_templateObject3, function (props) {
    return props.top + 'px';
  });

  var Scrollable = function (_React$Component) {
    _inherits(Scrollable, _React$Component);

    function Scrollable(props) {
      _classCallCheck(this, Scrollable);

      var _this = _possibleConstructorReturn(this, (Scrollable.__proto__ || Object.getPrototypeOf(Scrollable)).call(this, props));

      _this.state = {
        events: ['scroll', 'mousewheel', 'DOMMouseScroll', 'MozMousePixelScroll', 'resize', 'touchmove', 'touchend'],
        top: 0
      };

      _this.onScroll = _this.onScroll.bind(_this);
      return _this;
    }

    _createClass(Scrollable, [{
      key: 'componentDidMount',
      value: function componentDidMount() {
        var _this2 = this;

        this.props.onRef && this.props.onRef(this);
        this.state.events.forEach(function (ev) {
          if (window.addEventListener) {
            (0, _reactDom.findDOMNode)(_this2.inner).addEventListener(ev, _this2.onScroll, false);
          } else {
            (0, _reactDom.findDOMNode)(_this2.inner).attachEvent('on' + ev, _this2.onScroll, false);
          }
        });
      }
    }, {
      key: 'componentWillUnmount',
      value: function componentWillUnmount() {
        var _this3 = this;

        this.props.onRef && this.props.onRef(undefined);
        this.state.events.forEach(function (type) {
          if (window.addEventListener) {
            (0, _reactDom.findDOMNode)(_this3.inner).removeEventListener(type, _this3.onScroll, false);
          } else {
            (0, _reactDom.findDOMNode)(_this3.inner).attachEvent('on' + type, _this3.onScroll, false);
          }
        });
      }
    }, {
      key: 'onScroll',
      value: function onScroll(e) {
        var scrollTop = (0, _reactDom.findDOMNode)(this.inner).scrollTop;
        if (e.deltaY) this.inner.scrollTop += e.deltaY;
        var scrollPercentage = 100 * this.inner.scrollTop / (this.inner.scrollHeight - this.inner.clientHeight);
        var top = (this.track.clientHeight - this.thumb.clientHeight) * scrollPercentage / 100;
        this.setState({
          top: top
        });
        if (scrollPercentage < 99.99 || scrollPercentage > 0.01) {
          e.stopPropagation();
          e.preventDefault();
        }
      }
    }, {
      key: 'scrollToBottom',
      value: function scrollToBottom() {
        this.scrollbars && this.scrollbars.scrollToBottom && this.scrollbars.scrollToBottom();
      }
    }, {
      key: 'render',
      value: function render() {
        var _this4 = this;

        var _props = this.props,
            onRef = _props.onRef,
            minHeight = _props.minHeight,
            otherProps = _objectWithoutProperties(_props, ['onRef', 'minHeight']);

        return _react2.default.createElement(
          _ScrollableWrap2.default,
          { minHeight: minHeight },
          _react2.default.createElement(InnerWrap, _extends({ innerRef: function innerRef(el) {
              return _this4.inner = el;
            } }, otherProps)),
          _react2.default.createElement(
            Track,
            { innerRef: function innerRef(el) {
                return _this4.track = el;
              } },
            _react2.default.createElement(Thumb, { top: this.state.top, innerRef: function innerRef(el) {
                return _this4.thumb = el;
              } })
          )
        );
      }
    }]);

    return Scrollable;
  }(_react2.default.Component);

  Scrollable.propTypes = undefined !== "production" ? {
    theme: _propTypes2.default.object,
    minHeight: _propTypes2.default.string
  } : {};

  Scrollable.defaultProps = {
    theme: _defaultTheme2.default
  };

  Scrollable.displayName = ComponentName;

  exports.default = Scrollable;
});